#ifndef CDETECTOR
#define CDETECTOR

#include "RBody.hpp"
#include "Vector3.hpp"
#include "Collision.hpp"
#include <vector>

namespace CDetector
{
  bool DetectCollision(RBody* A, RBody* B);
  bool IsPointInside(Vector3 p, RBody* B);
  void CheckAll(std::vector<RBody*>* bodies, std::vector<Collision*>* collisions, std::vector<Collision*>* contacts, double eps);
  //void RecalculatePoints(Collision* col);
  void RememberPoints(Collision* col, RBody* A, RBody* B);
  //void RecheckAll(std::vector<Collision>* collisions);
  //double MaxPen(std::vector<Collision>* collisions);
  double PenDepth(RBody* A, RBody* B, Vector3 axis);
  double LineDistance(Edge a, Edge b);
  double RelativeVelocity(Vector3 p, Vector3 n, RBody* A, RBody* B);
  
  PointEvaluation EvaluatePoint(CollisionPoint cp, RBody* A, RBody* B);
  Collision*      GetCollisionPoints(RBody* A, RBody* B);
  Vector3         ClosestToPlane(RBody* A, Vector3 n, Vector3 p);
  Vector3         ClosestOnEdgeA(Edge A, Edge B);
}

#endif
