#ifndef COLLISION
#define COLLISION

#include "Vector3.hpp"
#include <vector>

class RBody;
class Edge;
class Face;

struct PointEvaluation
{
  Vector3 p;    // global space
  Vector3 n;    // global space
  double depth;
};

struct CollisionPoint
{
  Edge* eA;   // edge of A, edge-edge collision only
  Edge* eB;   // edge of B, edge-edge collision only
  Face* f;    // vertex-face collision only
  Vector3 p;  // local space
  Vector3 n;  // global space
};

struct Collision
{
  RBody* bodies[2];
  std::vector<CollisionPoint> points[2];
  
  /*CollisionPoint DeepestPoint()
  {
    CollisionPoint max_pen = points[0];
    double max_depth = points[0].depth;
    
    for (unsigned int i = 1; i < points.size(); i++)
    {
      if (points[i].depth > max_depth)
      {
        max_depth = points[i].depth;
        max_pen = points[i];
      }
    }
    return max_pen;
  }*/
};

#endif
