#ifndef MATRIX3X3
#define MATRIX3X3

#include "Vector3.hpp"
#include "Edge.hpp"

class Matrix3x3
{
  private:
    double values[3][3]; // [row][column]
    
  public:
    Matrix3x3(double a);
    Matrix3x3();
    double& operator()(unsigned char i, unsigned char j);
    void Print();
    Matrix3x3 operator*(Matrix3x3 m);
    Matrix3x3 operator+(Matrix3x3 m);
    Matrix3x3 operator-(Matrix3x3 m);
    Vector3 operator*(Vector3 v);
    Edge operator*(Edge e);
    Matrix3x3 operator*(double a);
    Matrix3x3 operator/(double a);
    Matrix3x3 operator=(Matrix3x3 v);
    bool operator==(Matrix3x3 v);
    Matrix3x3 ColumnCross(Vector3 v);
    Matrix3x3 Transpose();
    Matrix3x3 Inverse();
};

#endif
