#ifndef CNETWORK
#define CNETWORK

#include <string>
#include <vector>
#include "RBody.hpp"
#include "Player.hpp"

namespace Network
{
  enum Input
  {
    FORWARD_UP,
    FORWARD_DOWN,
    BACKWARD_UP,
    BACKWARD_DOWN,
    LEFT_UP,
    LEFT_DOWN,
    RIGHT_UP,
    RIGHT_DOWN
  };
  
  enum PacketType
  {
    MSG_SYNC_BODIES,
    MSG_SEND_INPUT,
    MSG_NONE
  };
 
  struct Command
  {
    PacketType type;
    unsigned int simulation_time;
    Input input;
    unsigned int id;
  };
  
  bool IsConnected();
  void Connect(std::string address_str, std::vector<RBody*>* bodies, std::vector<Player>* players_ptr);
  void CreateHost(std::vector<RBody*>* bodies, std::vector<Player>* players_ptr);
  void CloseHost();
  void CloseClient();
  Command HostLoop(unsigned int simulation_time, double* speed);
  void SendInput(Input in, unsigned int simulation_time, unsigned int controlled_idx);
  Command ClientLoop(double* speed);
};

#endif
