#ifndef ODESOLVER
#define ODESOLVER

#include "RBody.hpp"
#include <vector>

namespace ODESolver
{
  void EulerStep(RBody& rb, double delta_time);
  void EulerStepPos(RBody& rb, double delta_time);
  void EulerStepVel(RBody& rb, double delta_time);
  void RK4Step(RBody& rb, double delta_time);
  void EulerStepAll(std::vector<RBody*>* bodies, double delta_time);
  void RK4StepAll(std::vector<RBody*>* bodies, double delta_time);
  void EulerStepAllPos(std::vector<RBody*>* bodies, double delta_time);
  void EulerStepAllVel(std::vector<RBody*>* bodies, double delta_time);
}

#endif
