#ifndef QUATERNION
#define QUATERNION

#include "Vector3.hpp"

class Quaternion
{
  public:
    double s;
    Vector3 v;
    
    Quaternion();
    Quaternion(double a_s, Vector3 a_v);
    Quaternion(double x, double y, double z, double w);
    Quaternion operator*(Quaternion q);
    Quaternion operator+(Quaternion q);
    Quaternion operator*(double a);
    Quaternion operator/(double a);
    Quaternion operator=(Quaternion q);
    Quaternion Normalize();
    void Print();
};

#endif
