#ifndef RENDERER
#define RENDERER

#include "RBody.hpp"
#include "Collision.hpp"
#include <string>

namespace Renderer
{
  void InitDisplay(int* argc, char** argv, std::vector<RBody*>* bodies, std::vector<Collision*>* collisions, int w, int h);
  void Reshape(int w, int h);
  void DrawCollision(Collision* col);
  void DrawBody(RBody* rb);
  void DrawFloor(double x, double y, double z, double rows, double cols);
  void RenderBitmapString(float x, float y, void *font, std::string str);
  void Display();
  void SetCamera(double angle);
  int GetWidth();
  int GetHeight();
  Matrix3x3 CameraToWorld();
  void RotateCamera(float v, float h, bool up, bool down);
}

#endif
