#ifndef VECTOR3
#define VECTOR3

class Vector3
{
  private:
    double axes[3];
    double len;
    bool len_correct;
    
  public:
    Vector3(double x, double y, double z);
    Vector3();
    double Length();
    
    double inline x() { return axes[0]; }
    double inline y() { return axes[1]; }
    double inline z() { return axes[2]; }
    
    
    double& operator[](unsigned char i);
    double operator*(Vector3 v);
    Vector3 operator*(double a);
    Vector3 operator/(double a);
    Vector3 operator+(Vector3 v);
    Vector3 operator-(Vector3 v);
    Vector3 operator=(Vector3 v);
    Vector3 operator^(Vector3 v); // CROSS PRODUCT
    Vector3 operator+=(Vector3 v);
    Vector3 operator-=(Vector3 v);
    bool operator==(Vector3 v);
    Vector3 Normalized();
    bool IsAlmost(Vector3 v);
    void Print();
};

#endif
